<div class="sessions">
<div class="audio" id="audio">
    <img id="record-icon" class="mic-icon" src="{{ url_for('static', filename='img/miciconmuted.svg') }}" alt="Record Icon">
    <img id="stop-icon" class="mic-icon" src="{{ url_for('static', filename='img/mic_icon.svg') }}" alt="Stop Icon"
         style="display: none;">
    <p></p>
    <div id="level-display" class="level-display">
        <div id="level-bar" class="level-bar"></div>
    </div>
</div>
</div>

<script src="https://cdn.jsdelivr.net/npm/wave-resampler"></script>

<script>
  const recordIcon = document.getElementById("record-icon");
  const stopIcon = document.getElementById("stop-icon");
  const levelDisplay = document.getElementById("level-display");
  const levelBar = document.getElementById("level-bar");

  startedRecording = false;

function updateLevel() {
    let dataArray = new Uint8Array(analyserNode.frequencyBinCount);
    analyserNode.getByteFrequencyData(dataArray);

    let total = dataArray.reduce((sum, value) => sum + value, 0);
    let average = total / dataArray.length;
    let level = average / 256;
    levelBar.style.width= level * 100 + "%";

    requestAnimationFrame(updateLevel);
}

class Node {
  constructor(data) {
    this.data = data;
    this.next = null;
  }
}

class Queue {
  constructor() {
    this.front = null;
    this.rear = null;
    this.size = 0;
    this.sending = 0;
  }

  // Add an item to the rear of the queue
  enqueue(data) {
    const node = new Node(data);
    if (!this.front) {
      this.front = node;
      this.rear = node;
    } else {
      this.rear.next = node;
      this.rear = node;
    }
    this.size++;
  }

  // Remove an item from the front of the queue
  dequeue() {
    if (!this.front) {
      return null;
    }
    const node = this.front;
    this.front = this.front.next;
    if (!this.front) {
      this.rear = null;
    }
    this.size--;
    return node.data;
  }

  // Get the current size of the queue
  getSize() {
    return this.size;
  }
}

function concatenateInt16Arrays(queue, size) {
  chunk = queue.dequeue();

  // Create a new Int16Array with the combined length
  let concatenatedArray = new Int16Array(size*chunk.length);

  // Copy the contents of each array into the concatenated array
  for (let i = 0; i < size-1; i++) {
    concatenatedArray.set(chunk, i*chunk.length);
    chunk = queue.dequeue();
  }
  concatenatedArray.set(chunk, (size-1)*chunk.length);

  return concatenatedArray;
}

function convertFloat32ToInt16(buffer) {
  l = buffer.length;
  buf = new Int16Array(l);
  while (l--) {
      buf[l] = buffer[l]*0x7FFF;
  }
  return buf;
}

let time = Date.now();
let analyserNode;
let sent_pause = 0;

const queue = new Queue();
const chunksize = 16384;

function createAudioContext() {
  // Create an AudioContext instance
  const audioContext = new AudioContext();

  // Create a MediaStreamSource from the user's microphone
  navigator.mediaDevices.getUserMedia({ audio: true, video: false }).then((stream) => {
    audioSource = audioContext.createMediaStreamSource(stream);
    processor = audioContext.createScriptProcessor(chunksize, 1, 1);
    audioSource.connect(processor);
    processor.connect(audioContext.destination);

    const sampleRate = audioContext.sampleRate;

    analyserNode = audioContext.createAnalyser();
    audioSource.connect(analyserNode);
    requestAnimationFrame(updateLevel);

    processor.onaudioprocess = (event) => {
      if (stopIcon.style.display !== "none") {
          const audioFloat32 = event.inputBuffer.getChannelData(0);
          const audioFloat32_resampled = Float32Array.from(waveResampler.resample(audioFloat32, audioContext.sampleRate, 16000));
          const audioInt16 = convertFloat32ToInt16(audioFloat32_resampled);
          queue.enqueue(audioInt16);
      }
    }
  });
}

setInterval(function() {
  const size = queue.getSize();
  if (size > 0 && queue.sending === 0) {
    queue.sending = 1;

    const audioInt16 = concatenateInt16Arrays(queue, size);

    var audioString = '';
    var bytes = new Uint8Array(audioInt16.buffer);
    for (var i = 0; i < bytes.length; i++) {
      audioString += String.fromCharCode(bytes[i]);
    }

    time += audioString.length / 32; // pcm_s16le has 32 bytes per millisecond
    message = { "b64_enc_pcm_s16le": btoa(audioString), "start":time/1000 };
    if (typeof speaker !== 'undefined') {
      message["speaker"] = speaker
	}
	console.log("Send to stream: {{ stream }}")
    fetch('{{ server }}/{{ session }}/{{ stream }}/append', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(JSON.stringify(message))
    })
    .then(response => {
        queue.sending = 0;
        sent_pause = 0;
    })
    .catch(error => {
      console.log("ERROR in post request!");
      queue.sending = 0;
    });

  } else if (sent_pause === 0 && stopIcon.style.display === "none") {
      sent_pause = 1;
        console.log("SENDING PAUSE");
        message = { "b64_enc_pcm_s16le": btoa("PAUSE")};
        fetch('{{ server }}/{{ session }}/{{ stream }}/append', {
          method: 'POST',
          headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(JSON.stringify(message))
        });
  }
}, 100);

function recording() {
    if (!startedRecording) {
        createAudioContext();
        startedRecording = true;
    }
    time = Date.now();
    recordIcon.style.display = "none";
    stopIcon.style.display = "inline-block";
    levelBar.style.display = "block";
}

recordIcon.addEventListener("click", recording);

function stop_recording() {
    stopIcon.style.display = "none";
    recordIcon.style.display = "inline-block";
    levelBar.style.display = "none";
}

stopIcon.addEventListener("click", function() {
    stop_recording();
});

{% if correction_mode_deactivated == True %}
    stop_recording();
{% else %}
    recording();
{% endif %}

// Object to keep track of key states
var keyState = {};

console.log("Requesting keyboard stream");

fetch('{{ server }}/{{ session }}/addstreamlog', {
  method: 'POST',
})
.then(stream => stream.text())
.then(stream => {

console.log("Got stream "+stream);

document.addEventListener('keydown', function(event) {
    // Check if the key is already pressed
    if (!keyState[event.key]) {
        time_ = Date.now();
        // Key is not pressed, so log it and set its state to pressed
        console.log('Key pressed: ' + event.key + ' ' + time_/1000);

        data = { "keyboard_press": event.key, "time":time_/1000 };

        fetch('{{ server }}/{{ session }}/'+stream+'/append', {
          method: 'POST',
          headers: {
            'Content-Type': 'application/json',
          },
          body: JSON.stringify(JSON.stringify(data)),
        });

        keyState[event.key] = true;
        // You can add your custom logic here
    }
});

document.addEventListener('keyup', function(event) {
    time_ = Date.now();

    // Log that the key is released and set its state to released
    console.log('Key released: ' + event.key + ' ' + time_/1000);

    data = { "keyboard_release": event.key, "time":time_/1000 };

    fetch('{{ server }}/{{ session }}/'+stream+'/append', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify(JSON.stringify(data)),
    });

    keyState[event.key] = false;
    // You can add your custom logic here
});

});

var sent_end = false;

window.addEventListener("beforeunload", (event) => {
    if (!sent_end) {
        event.preventDefault();
        event.returnValue = "Please do not close before pressing 'End Lecture'";
    }
});

</script>
